/*
 * This defines the events called at breakpoints for debugging
 */

typedef enum {
  enterSearch,
  leaveSearch,
  enterNode,
  leaveNode,
  unitPropagate,
  enterTest,
  leaveTest,
  solution,
  abortSearch,
  MAX_EVENT
} event_id;

typedef enum {
  unsubscribed,
  collect_only,
  non_blocking_send,
  blocking_send
} subscription_level;

typedef enum {
  SETPOSSES,
  DOSMALLS,
  SEARCHES,
  SOLUTIONS,
  BAD_TESTS,
  SURJ_BACKTRACKS,
  NULL_BACKTRACKS,
  VECMAX,
  INVALUES,
  FLIPS,
  PREREFS,
  REFSIZE,
  TOPLESS,
  LOC_MEMORY,
  MEMORY,
  F_SUBSUMED,
  B_SUBSUMED,
  B1_SUBSUMED,
  SOFT_DOUBLE,
  BRANCHES,
  PRE_TIME,
  SEARCH_TIME,
  STOP_CODE,
  MAX_REPORT
} report_code;

#define EVENTNAMELENGTH 50

#ifndef boolean
#define boolean char
#define false ((boolean)0)
#define true ((boolean)1)
#endif

typedef struct {
  event_id uid;
  char name[EVENTNAMELENGTH];
  char shortname[EVENTNAMELENGTH];
  subscription_level subscribed;
  boolean in_mask[MAX_REPORT];    // Info to be collected 
  boolean out_mask[MAX_REPORT];   // Info to be sent
} DEBUG_EVENT, *debug_event;
