#define MAINFILE
#include "FINDER.h"

int main(argc,argv)

int argc;
char *argv[];
{
  FILE *infil;
  char filename[64];
  boolean pipe_out = false;
  boolean debugging = false;

  *filename = 0;
  initial_initial();

  get_options(argc,argv,&debugging,filename,0,&pipe_out);
  
  /*
  signal(SIGALRM, timesup);
  */
  signal(SIGINT, intrupt);
  if (!debugging) {
  /*
    alarm(MAXREADTIME);
  */
    set_maxtime(MAXREADTIME);
    reset_timer();
  }

  initialize();
  read_job(stdin,0);
  pipe_open = false;
  if (piping) {
    if (!(infil = fopen(filename,"r")))
      inerror("Cannot open file",filename,false);
    read_job(infil,0);
  }
  if (*(command_line.c_str)) {
    cmd_line_input = true;
    read_job(0,0);
  }
  if (pipe_out) {
    dynstring_strcpyc(&command_line, "setting ugly end.");
    cmd_line_input = true;
    input_point = 0;
    read_job(0,0);
  }
  // No more reading of job input after this

  if (!setting.outf && !setting.outi)
    setting.outf = stdout;
  if (!setting.random) srand48(9541920);
  //  alarm(0);                         // Cancel default time limit
  tr_parameters.done = 0;
  satisfied = false;
  if (setting.maxtime == 0 || setting.maxtime > MAXTIME)
    setting.maxtime = MAXTIME;
  //  alarm(setting.maxtime);           // Set new time limit
  set_maxtime(setting.maxtime);
  reset_timer();
  begin_time = timestamp();
  demote_hiddens();
  if (setting.pm.verbosity[pjob]) print_job();
  if (setting.parse_only || setting.clausify_only) {
    if (setting.outf)
      fprintf(setting.outf,"\nSyntax checked...OK\n");
    if (setting.outi)
      iprintf(setting.outi,"\nSyntax checked...OK\n");
  }
  else if (piping) {
    while (!tr_parameters.done && got_partial()) {
      satisfied = false;
      not_searching_yet = false;
      go(0,0);
      if (negative && !satisfied) {
	updates[current_theory]++;
	print_model();
	if (updates[current_theory] && 
	     updates[current_theory] == setting.max_models)
	  job_done(&tr_parameters, ENOUGH_SOLUTIONS);
      }
    }
  }
  else {
    not_searching_yet = false;
    go(0,0);
  }
  end_time = timestamp();
  free_tables();
  free_clauses();

  if (!setting.pm.pretty) {
    if (setting.outf)
      fprintf(setting.outf,"end\n");
    if (setting.outi)
      iprintf(setting.outi,"end\n");
  }
  if (setting.pm.verbosity[pstats])
    printstats();
  else if (!setting.parse_only && !setting.clausify_only) {
    if (tr_parameters.done && !tr_parameters.report_breaks)
      stopped_by(&(tr_parameters));
    else if (!tr_parameters.reps[SOLUTIONS].i_report) {
      if (setting.outf)
	fprintf(setting.outf,"\n  No solution found.\n");
      if (setting.outi)
	iprintf(setting.outi,"\n  No solution found.\n");
    }
  }
  fflush(stdout);

  //  alarm(0);

  exit (0);
}
