
#include "FINDER.h"


void get_sizes(int icomvec[], int vlength)
// Set icomvec[i] to the number of values for cell #i plus one for the
// junk value.
{
  functor f;
  int arguments[ARGMAX];
  int x;

  for (f=FN; f; f=f->nextfunct)
    /*
     *    if (!f->piped) {
     */
    if (1) {
      for (x=0; x<f->adicity; x++)
	arguments[x] = 0;
      do
	icomvec[vec_pos(f,arguments)] = f->val_type->siz + 1;
      while (another_argument(f,arguments));
      icomvec[f->fcc] = f->val_type->siz + 1;
      f->val_type->is_val = true;
    }
}



/*
* Setposs is called from transref to trim the search space by removing
* impossible values from the vector of sets of possibilities. Note that
* according to TRANSREF this function should only subtract values, never
* add them.
*
* First it sets upper bounds according to the cardinalities of the 
* domains, then it looks to clauses of weight 1 to take out further
* impossible values. Clauses which are of local weight 1 but not of 
* absolute weight 1 will get treated a little later in do_twos.
*
* Clauses of weight 0 (which must include piped stuff) are dealt with
* at this point, and need never again be checked.
*/

boolean setposs(set info[], TRS *T)
{
  functor f;
  clause c;
  int i;

  for (i=0; form[i].sym; i++) {
    if (form[i].sym->category == Const)
      form[i].val = *(form[i].sym->table);
  }

  set_priority(FN,T);
  set_sizmask();

  for (f=FN; f; f=f->nextfunct)
    /*
     *    if (!f->piped)
     */
      set_possval(info,f,T);

  for (c=TH[current_theory]; c; c=c->nextclause)
    c->preprocessed = false;

  for (c=TH[current_theory]; c && !T->job->done; c=c->nextclause)
    if (!c->weight) {
      c->preprocessed = true;
      if (!setposs_test(info,c,0,T))
	return false;
    }
    else if (c->weight==1) {
      c->preprocessed = true;
      if (!good_one(info,c,T))
	return false;
    }
  return true;
}



/*
* The set of possible values is trimmed to exclude any which are bigger
* than the highest within the domain of the value sort. Special allowance
* has to be made for the dummy value in cases of dummy arguments.
*/

void set_possval(set info[], functor f, TRS *T)
{
  set mask;
  int argument[ARGMAX];
  boolean undefined;
  int i;

  mask = S_new(f->val_type->siz,0);
  S_fill(mask,(f->total? f->val_type->siz-1: f->val_type->siz));
  for (i=0; i<f->adicity; i++)
    argument[i] = 0;
  do {
    undefined = false;
    for (i=0; i<f->adicity; i++)
      if (argument[i] == f->arg_type[i]->siz)
	undefined = true;
    if (undefined)
      S_singleton(f->val_type->siz,info[vec_pos(f,argument)]);
    else if (f->piped)
      S_singleton(f->table[getoffset(f,argument)],info[vec_pos(f,argument)]);
    else
      S_intersection(info[vec_pos(f,argument)],mask,info[vec_pos(f,argument)]);
  }
  while (another_argument(f,argument));
  S_free(mask);
}


boolean another_argument(functor f, int argument[])
{
  int i;

  for (i=0; i<f->adicity; i++) {
    if (argument[i] < f->arg_type[i]->siz) {
      argument[i]++;
      return true;
    }
    else argument[i] = 0;
  }
  return false;
}




int set_priority(functor f, TRS *T)
{
  int i;
  int x;
  int argument[ARGMAX];

  if (!f) return 0;
  x = set_priority(f->nextfunct, T);
  /*
   *  if (f->piped) return x;
   */
  if (x > 0 && f->nop) x--;
  for (i=0; i<f->adicity; i++) argument[i] = 0;
  do
    co_priority(vec_pos(f,argument),x,T);
  while (another_argument(f,argument));
  return x+1;
}




/*
 * Test a formula known to have exactly one open function symbol.
 * Remove impossible values from the relevant cell of info.
 * Return false if there is a wipeout, true if not.
 */

boolean good_one(set info[], clause c, trs T)
{  
  wff_stack tf;
  int sz;

  for (tf = c->testlist;
       tf && !is_open(tf->w->sym);
       tf = tf->nxt)
    ;
  sz = tf->w->sym->val_type->siz+1;
  for (tf->w->val = 0; tf->w->val < sz; tf->w->val++)
    if (!setposs_test(info, c, tf, T))
      return false;
  return true;
}




boolean setposs_test(set info[], clause c, wff_stack tf, trs T)
{
  wff_stack wf, check;
  wff ww;
  int vp;
  boolean failure;
  int i;
  int subvalues[ARGMAX];

  for (wf=c->varlist; wf; wf=wf->nxt)
    wf->w->val = wf->w->sym->val_type->siz-1;
  do {
    for (wf=c->testlist; wf; wf=wf->nxt)
      if (wf != tf) {
	ww = wf->w;
	for (i=0; i<ww->sym->adicity; i++)
	  subvalues[i] = *(ww->sbval[i]);
	if (ww->matrix)
	  ww->val = *(ww->matrix + getoffset(ww->sym,subvalues));
	else
	  ww->val = builtin(ww->sym,subvalues);
      }
    failure = true;
    for (check=c->prem; check; check=check->nxt)
      if (!check->w->val) failure = false;
    for (check=c->conc; check; check=check->nxt)
      if (check->w->val) failure = false;
    if (failure) {
      if (!tf) return false;
      for (i=0; i<tf->w->sym->adicity; i++)
	subvalues[i] = *(tf->w->sbval[i]);
      vp = vec_pos(tf->w->sym, subvalues);
      if (c->softweight)
	add_penalty(vp,tf->w->val,c->softweight,T);
      else {
	S_outof(tf->w->val,info[vp]);
	if (S_size(info[vp]) == 0) return false;
      }
    }
    if (T->job->done)
      return false;
  }
  while (next_assignment(c));
  return true;
}
